void halfStep(int nbSteps, int speedMotor){

  //répéter autant de fois qu'il faut faire de pas
  for(int i=0;i<nbSteps;i++){
    
    //on choisit le sens de rotation moteur en fonction du signe de la vitesse
    //positif : horaire en regardant le moteur de face> la table s'ouvre
    if(speedMotor>=0){
      if(currentStep<7){
        currentStep+=1;
      }
      else{
        currentStep=0;
      }
      halfStepFromOrigin+=1;
    }
    //négatif : antihoraire
    else{
      if(currentStep>0){
        currentStep-=1;
      }
      else{
        currentStep=7;
      }
      halfStepFromOrigin-=1;
    }
    byteToSend=halfStepSequence[currentStep];
    
    //Serial.println(byteToSend);
    digitalWrite(coilA,(byteToSend&B10000000)>>7);
    //Serial.println((byteToSend&B10000000)>>7);
    digitalWrite(coilB,(byteToSend&B01000000)>>6);
    //Serial.println((byteToSend&B01000000)>>6);
    digitalWrite(coilC,(byteToSend&B00100000)>>5);
    //Serial.println((byteToSend&B00100000)>>5);
    digitalWrite(coilD,(byteToSend&B00010000)>>4);
    //Serial.println((byteToSend&B00010000)>>4);
    //Serial.println("------------");
    
    delay(timeStep);// how much time we maintain power (depends on load and battery voltage)
    //and then cut power
    stopMotorNoTorque();
    
    //print current step
    //Serial.println(halfStepFromOrigin);

    delay(abs(speedMotor));//speed management (careful : when higher > slower)
  }
  
  
}

void fullStep(int nbSteps, int speedMotor){
  //for full torque or full speed (careful with current and heat!) 
  
  for(int i=0;i<nbSteps;i++){
    if(speedMotor>=0){
      if(currentStep<3){
        currentStep+=1;
      }
      else{
        currentStep=0;
      }
      halfStepFromOrigin+=2;
    }
    else{
      if(currentStep>0){
        currentStep-=1;
      }
      else{
        currentStep=3;
      }
      halfStepFromOrigin-=2;
    }
    byteToSend=fullStepSequence[currentStep];
    
    //Serial.println(byteToSend);
    digitalWrite(coilA,(byteToSend&B10000000)>>7);
    //Serial.println((byteToSend&B10000000)>>7);
    
    digitalWrite(coilB,(byteToSend&B01000000)>>6);
    //Serial.println((byteToSend&B01000000)>>6);
    
    digitalWrite(coilC,(byteToSend&B00100000)>>5);
    //Serial.println((byteToSend&B00100000)>>5);
    
    digitalWrite(coilD,(byteToSend&B00010000)>>4);
    //Serial.println((byteToSend&B00010000)>>4);
    //Serial.println("------------");
    
    
    delay(timeStepFull);// how much time we maintain power (depends on load and battery voltage)
    //and then cut power
    stopMotorNoTorque();
    
    delay(abs(speedMotor));//speed management (careful : when higher > slower)
    
    //print current step
    //Serial.println(halfStepFromOrigin);
  }
  
  
  
}

void stopMotorNoTorque(){
  //stop the motor without retaining torque (no current) 
  digitalWrite(coilA,0);
  digitalWrite(coilB,0);
  digitalWrite(coilC,0);
  digitalWrite(coilD,0);
}
